/* ---------- */
/* floatlib.h */
/* ---------- */

# if defined(__FLOATLIB_H__)
#	/* DO NOTHING */
# else
#	define	__FLOATLIB_H__

#ifdef __cplusplus
extern "C" {
#endif

/* ------------------- */
/* FUNCTION PROTOTYPES */
/* ------------------- */
# undef F
# if defined(__STDC__) || defined(__PROTO__)
#	define  F( P )  P
# else
#	define  F( P )  ()
# endif

/* INDENT OFF */
extern	float	acosf	F((float));
extern	float	acoshf	F((float));
extern	void	airyf	F((float, float *, float *, float *, float *));
extern	float	asinf	F((float));
extern	float	asinhf	F((float));
extern	float	atan2f	F((float, float));
extern	float	atanf	F((float));
extern	float	atanhf	F((float));
extern	float	bdtrcf	F((int, int, float));
extern	float	bdtrf	F((int, int, float));
extern	float	bdtrif	F((int, int, float));
extern	float	betaf	F((float, float));
extern	float	cabsf	F((void *));
extern	void	cacosf	F((void *, void *));
extern	void	caddf	F((void *, void *, void *));
extern	void	casinf	F((void *, void *));
extern	void	catanf	F((void *, void *));
extern	float	cbrtf	F((float));
extern	void	cchshf	F((float, float *, float *));
extern	void	ccosf	F((void *, void *));
extern	void	ccotf	F((void *, void *));
extern	void	cdivf	F((void *, void *, void *));
extern	float	ceilf	F((float));
extern	void	cexpf	F((void *, void *));
extern	float	chbevlf	F((double, float *, int));
extern	float	chdtrcf	F((float, float));
extern	float	chdtrf	F((float, float));
extern	float	chdtrif	F((float, float));
extern	void	clogf	F((void *, void *));
extern	int	cmovf	F((short *, short *));
extern	int	cmulf	F((void *, void *, void *));
extern	int	cnegf	F((void *));
extern	float	cosdgf	F((float));
extern	float	cosf	F((float));
extern	float	coshf	F((float));
extern	float	cotdgf	F((float));
extern	float	cotf	F((float));
extern	void	csinf	F((void *, void *));
extern	void	csqrtf	F((void *, void *));
extern	int	csubf	F((void *, void *, void *));
extern	void	ctanf	F((void *, void *));
extern	float	ctansf	F((void *));
extern	float	dawsnf	F((float));
extern	float	ellief	F((double, double));
extern	float	ellikf	F((double, double));
extern	float	ellpef	F((float));
extern	float	ellpjf	F((float, float, float *, float *, float *, float *));
extern	float	ellpkf	F((float));
extern	float	erfcf	F((float));
extern	float	erff	F((float));
extern	float	exp10f	F((float));
extern	float	exp2f	F((float));
extern	float	expf	F((float));
extern	float	expnf	F((int, float));
extern	float	facf	F((int));
extern	float	fdtrcf	F((int, int, float));
extern	float	fdtrf	F((int, int, int));
extern	float	fdtrif	F((int, int, float));
extern	float	floorf	F((float));
extern	void	fresnlf	F((float, float *, float *));
extern	float	frexpf	F((float, int *));
extern	float	gammaf	F((float));
extern	float	gdtrcf	F((float, float, float));
extern	float	gdtrf	F((float, float, float));
extern	float	hyp2f0f	F((float, float, float, int, float *));
extern	float	hyp2f1f	F((float, float, float, float));
extern	float	hypergf	F((float, float, float));
extern	float	i0ef	F((float));
extern	float	i0f	F((float));
extern	float	i1ef	F((float));
extern	float	i1f	F((float));
extern	float	igamcf	F((float, float));
extern	float	igamf	F((float, float));
extern	float	igamif	F((int, int));
extern	double	incbet	F((double, double, double));
extern	float	incbetf	F((float, float, float));
extern	float	incbif	F((float, float, float));
extern	float	incbpsf	F((float, float, float));
extern	float	ivf	F((float, float));
extern	float	j0f	F((float));
extern	float	j1f	F((float));
extern	float	jnf	F((int, float));
extern	float	jvf	F((float, float));
extern	float	k0ef	F((float));
extern	float	k0f	F((int));
extern	float	k1ef	F((float));
extern	float	k1f	F((float));
extern	float	knf	F((int, float));
extern	float	ldexpf	F((float, int));
extern	float	lgamf	F((float));
extern	float	log10f	F((float));
extern	float	log2f	F((float));
extern	float	logf	F((float));
extern	int	mtherr	F((char *, int));
extern	float	nbdtrcf	F((int, int, float));
extern	float	nbdtrf	F((int, int, float));
extern	float	ndtrf	F((float));
extern	float	ndtrif	F((float));
extern	float	onef2f	F((double, double, double, double, float *));
extern	float	p1evlf	F((double, float *, int));
extern	float	pdtrcf	F((int, float));
extern	float	pdtrf	F((int, float));
extern	float	pdtrif	F((int, float));
extern	void	poladdf	F((float *, int, float *, int, float *));
extern	void	polclrf	F((float *, int));
extern	int	poldivf	F((float *, int, float *, int, float *));
extern	float	polevaf	F((float *, int, float));
extern	float	polevlf	F((double, float *, int));
extern	void	polinif	F((int));
extern	void	polmovf	F((float *, int, float *));
extern	void	polmulf	F((float *, int, float *, int, float *));
extern	void	polprtf	F((float *, int, int));
extern	void	polsbt	F((float *, int, float *, int, float *));
extern	void	polsubf	F((float *, int, float *, int, float *));
extern	float	powf	F((float, float));
extern	float	powif	F((float, int));
extern	float	psif	F((float));
extern	float	redupif	F((float));
extern	float	rgammaf	F((float));
extern	int	shichif	F((float, float *, float *));
extern	int	sicif	F((float, float *, float *));
extern	float	sindgf	F((float));
extern	float	sinf	F((float));
extern	float	sinhf	F((float));
extern	float	spencef	F((float));
extern	float	sqrtf	F((float));
extern	float	stdtrf	F((int, float));
extern	float	struvef	F((double, double));
extern	float	tandgf	F((float));
extern	float	tanf	F((float));
extern	float	tanhf	F((float));
extern	float	y0f	F((float));
extern	float	y1f	F((float));
extern	float	ynf	F((int, float));
extern	float	yvf	F((double, double));
extern	float	zetacf	F((float));
extern	float	zetaf	F((float, float));

# undef F
/* INDENT ON */

#ifdef __cplusplus
}
#endif

# endif			/* __FLOATLIB_H__ */
